<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "organization_entity_match".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "OrganizationEntityMatch".
 *
 * Columns in table "organization_entity_match" available as properties of the model,
 * followed by relations of table "organization_entity_match" available as properties of the model.
 *
 * @property integer $id
 * @property integer $organization_id
 * @property string $match_column_name
 * @property string $match_column_value
 * @property string $internal_entity_type
 * @property string $internal_column_name
 * @property integer $internal_column_value
 * @property string $retrieved_entity_type
 * @property string $retrieved_column_name
 * @property string $retrieved_column_value
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Organization $organization
 */
abstract class BaseOrganizationEntityMatch extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'organization_entity_match';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'OrganizationEntityMatch|OrganizationEntityMatches', $n);
    }

    public static function representingColumn()
    {
        return 'match_column_name';
    }

    public function rules()
    {
        return array(
            array('organization_id', 'required'),
            array('organization_id, internal_column_value', 'numerical', 'integerOnly' => true),
            array('match_column_name, match_column_value', 'length', 'max' => 255),
            array('internal_entity_type, internal_column_name, retrieved_entity_type, retrieved_column_name, retrieved_column_value', 'length', 'max' => 120),
            array('date_added, date_updated', 'safe'),
            array('match_column_name, match_column_value, internal_entity_type, internal_column_name, internal_column_value, retrieved_entity_type, retrieved_column_name, retrieved_column_value, date_added, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, organization_id, match_column_name, match_column_value, internal_entity_type, internal_column_name, internal_column_value, retrieved_entity_type, retrieved_column_name, retrieved_column_value, date_added, date_updated', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'organization_id' => null,
            'match_column_name' => Yii::t('app', 'Match Column Name'),
            'match_column_value' => Yii::t('app', 'Match Column Value'),
            'internal_entity_type' => Yii::t('app', 'Internal Entity Type'),
            'internal_column_name' => Yii::t('app', 'Internal Column Name'),
            'internal_column_value' => Yii::t('app', 'Internal Column Value'),
            'retrieved_entity_type' => Yii::t('app', 'Retrieved Entity Type'),
            'retrieved_column_name' => Yii::t('app', 'Retrieved Column Name'),
            'retrieved_column_value' => Yii::t('app', 'Retrieved Column Value'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'organization' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('match_column_name', $this->match_column_name, true);
        $criteria->compare('match_column_value', $this->match_column_value, true);
        $criteria->compare('internal_entity_type', $this->internal_entity_type, true);
        $criteria->compare('internal_column_name', $this->internal_column_name, true);
        $criteria->compare('internal_column_value', $this->internal_column_value);
        $criteria->compare('retrieved_entity_type', $this->retrieved_entity_type, true);
        $criteria->compare('retrieved_column_name', $this->retrieved_column_name, true);
        $criteria->compare('retrieved_column_value', $this->retrieved_column_value, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
